package it.unibo.lbedogni.locationlistener;

import android.content.pm.PackageManager;
import android.location.Address;
import android.location.Geocoder;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Build;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.widget.TextView;

import java.io.IOException;
import java.util.Locale;

public class MainActivity extends AppCompatActivity implements LocationListener {

    android.widget.TextView tvGpsCoord;
    TextView tvLocation;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        tvGpsCoord = (TextView)findViewById(R.id.tvGpsCoord);
        tvLocation = (TextView)findViewById(R.id.tvLocation);

        LocationManager lm = (LocationManager)getSystemService(LOCATION_SERVICE);
        //if (checkSelfPermission(android.Manifest.permission.ACCESS_FINE_LOCATION) == PackageManager.PERMISSION_GRANTED)
        //{
        if (Build.VERSION.SDK_INT >= 23 && checkSelfPermission(android.Manifest.permission.ACCESS_FINE_LOCATION) == PackageManager.PERMISSION_GRANTED) {
            lm.requestLocationUpdates(LocationManager.GPS_PROVIDER, 0, 0, this);
        } else {
            lm.requestLocationUpdates(LocationManager.GPS_PROVIDER, 0, 0, this);
        }
        //}

    }

    @Override
    public void onLocationChanged(Location location) {
        Log.v("Location", "has changed");
        tvGpsCoord.setText(String.valueOf(location.getLatitude() + ":" + String.valueOf(location.getLongitude())));

        Geocoder geocoder;

        geocoder = new Geocoder(this, Locale.getDefault());
        Address add;
        try {
            add = geocoder.getFromLocation(location.getLatitude(), location.getLongitude(), 1).get(0);
            tvLocation.setText(add.getCountryName() + "," + add.getThoroughfare() + "," + add.getPostalCode());
        } catch (IOException e) {
            e.printStackTrace();
        }

    }

    @Override
    public void onStatusChanged(String provider, int status, Bundle extras) {

    }

    @Override
    public void onProviderEnabled(String provider) {

    }

    @Override
    public void onProviderDisabled(String provider) {

    }
}
